]> git.street.me.uk Git - andy/dehydrated.git/blob - dehydrated
Skip challenge for already validated domains (#293)
[andy/dehydrated.git] / dehydrated
1 #!/usr/bin/env bash
2
3 # dehydrated by lukas2511
4 # Source: https://github.com/lukas2511/dehydrated
5 #
6 # This script is licensed under The MIT License (see LICENSE for more information).
7
8 set -e
9 set -u
10 set -o pipefail
11 [[ -n "${ZSH_VERSION:-}" ]] && set -o SH_WORD_SPLIT && set +o FUNCTION_ARGZERO
12 umask 077 # paranoid umask, we're creating private keys
13
14 # Find directory in which this script is stored by traversing all symbolic links
15 SOURCE="${0}"
16 while [ -h "$SOURCE" ]; do # resolve $SOURCE until the file is no longer a symlink
17   DIR="$( cd -P "$( dirname "$SOURCE" )" && pwd )"
18   SOURCE="$(readlink "$SOURCE")"
19   [[ $SOURCE != /* ]] && SOURCE="$DIR/$SOURCE" # if $SOURCE was a relative symlink, we need to resolve it relative to the path where the symlink file was located
20 done
21 SCRIPTDIR="$( cd -P "$( dirname "$SOURCE" )" && pwd )"
22
23 BASEDIR="${SCRIPTDIR}"
24
25 # Create (identifiable) temporary files
26 _mktemp() {
27   # shellcheck disable=SC2068
28   mktemp ${@:-} "${TMPDIR:-/tmp}/dehydrated-XXXXXX"
29 }
30
31 # Check for script dependencies
32 check_dependencies() {
33   # just execute some dummy and/or version commands to see if required tools exist and are actually usable
34   openssl version > /dev/null 2>&1 || _exiterr "This script requires an openssl binary."
35   _sed "" < /dev/null > /dev/null 2>&1 || _exiterr "This script requires sed with support for extended (modern) regular expressions."
36   command -v grep > /dev/null 2>&1 || _exiterr "This script requires grep."
37   _mktemp -u > /dev/null 2>&1 || _exiterr "This script requires mktemp."
38   diff -u /dev/null /dev/null || _exiterr "This script requires diff."
39
40   # curl returns with an error code in some ancient versions so we have to catch that
41   set +e
42   curl -V > /dev/null 2>&1
43   retcode="$?"
44   set -e
45   if [[ ! "${retcode}" = "0" ]] && [[ ! "${retcode}" = "2" ]]; then
46     _exiterr "This script requires curl."
47   fi
48 }
49
50 store_configvars() {
51   __KEY_ALGO="${KEY_ALGO}"
52   __OCSP_MUST_STAPLE="${OCSP_MUST_STAPLE}"
53   __PRIVATE_KEY_RENEW="${PRIVATE_KEY_RENEW}"
54   __KEYSIZE="${KEYSIZE}"
55   __CHALLENGETYPE="${CHALLENGETYPE}"
56   __HOOK="${HOOK}"
57   __WELLKNOWN="${WELLKNOWN}"
58   __HOOK_CHAIN="${HOOK_CHAIN}"
59   __OPENSSL_CNF="${OPENSSL_CNF}"
60   __RENEW_DAYS="${RENEW_DAYS}"
61   __IP_VERSION="${IP_VERSION}"
62 }
63
64 reset_configvars() {
65   KEY_ALGO="${__KEY_ALGO}"
66   OCSP_MUST_STAPLE="${__OCSP_MUST_STAPLE}"
67   PRIVATE_KEY_RENEW="${__PRIVATE_KEY_RENEW}"
68   KEYSIZE="${__KEYSIZE}"
69   CHALLENGETYPE="${__CHALLENGETYPE}"
70   HOOK="${__HOOK}"
71   WELLKNOWN="${__WELLKNOWN}"
72   HOOK_CHAIN="${__HOOK_CHAIN}"
73   OPENSSL_CNF="${__OPENSSL_CNF}"
74   RENEW_DAYS="${__RENEW_DAYS}"
75   IP_VERSION="${__IP_VERSION}"
76 }
77
78 # verify configuration values
79 verify_config() {
80   [[ "${CHALLENGETYPE}" =~ (http-01|dns-01) ]] || _exiterr "Unknown challenge type ${CHALLENGETYPE}... can not continue."
81   if [[ "${CHALLENGETYPE}" = "dns-01" ]] && [[ -z "${HOOK}" ]]; then
82     _exiterr "Challenge type dns-01 needs a hook script for deployment... can not continue."
83   fi
84   if [[ "${CHALLENGETYPE}" = "http-01" && ! -d "${WELLKNOWN}" ]]; then
85     _exiterr "WELLKNOWN directory doesn't exist, please create ${WELLKNOWN} and set appropriate permissions."
86   fi
87   [[ "${KEY_ALGO}" =~ ^(rsa|prime256v1|secp384r1)$ ]] || _exiterr "Unknown public key algorithm ${KEY_ALGO}... can not continue."
88   if [[ -n "${IP_VERSION}" ]]; then
89     [[ "${IP_VERSION}" = "4" || "${IP_VERSION}" = "6" ]] || _exiterr "Unknown IP version ${IP_VERSION}... can not continue."
90   fi
91 }
92
93 # Setup default config values, search for and load configuration files
94 load_config() {
95   # Check for config in various locations
96   if [[ -z "${CONFIG:-}" ]]; then
97     for check_config in "/etc/dehydrated" "/usr/local/etc/dehydrated" "${PWD}" "${SCRIPTDIR}"; do
98       if [[ -f "${check_config}/config" ]]; then
99         BASEDIR="${check_config}"
100         CONFIG="${check_config}/config"
101         break
102       fi
103     done
104   fi
105
106   # Default values
107   CA="https://acme-v01.api.letsencrypt.org/directory"
108   LICENSE="https://letsencrypt.org/documents/LE-SA-v1.1.1-August-1-2016.pdf"
109   CERTDIR=
110   ACCOUNTDIR=
111   CHALLENGETYPE="http-01"
112   CONFIG_D=
113   DOMAINS_D=
114   DOMAINS_TXT=
115   HOOK=
116   HOOK_CHAIN="no"
117   RENEW_DAYS="30"
118   KEYSIZE="4096"
119   WELLKNOWN=
120   PRIVATE_KEY_RENEW="yes"
121   PRIVATE_KEY_ROLLOVER="no"
122   KEY_ALGO=rsa
123   OPENSSL_CNF="$(openssl version -d | cut -d\" -f2)/openssl.cnf"
124   CONTACT_EMAIL=
125   LOCKFILE=
126   OCSP_MUST_STAPLE="no"
127   IP_VERSION=
128
129   if [[ -z "${CONFIG:-}" ]]; then
130     echo "#" >&2
131     echo "# !! WARNING !! No main config file found, using default config!" >&2
132     echo "#" >&2
133   elif [[ -f "${CONFIG}" ]]; then
134     echo "# INFO: Using main config file ${CONFIG}"
135     BASEDIR="$(dirname "${CONFIG}")"
136     # shellcheck disable=SC1090
137     . "${CONFIG}"
138   else
139     _exiterr "Specified config file doesn't exist."
140   fi
141
142   if [[ -n "${CONFIG_D}" ]]; then
143     if [[ ! -d "${CONFIG_D}" ]]; then
144       _exiterr "The path ${CONFIG_D} specified for CONFIG_D does not point to a directory." >&2
145     fi
146
147     for check_config_d in "${CONFIG_D}"/*.sh; do
148       if [[ ! -e "${check_config_d}" ]]; then
149         echo "# !! WARNING !! Extra configuration directory ${CONFIG_D} exists, but no configuration found in it." >&2
150         break
151       elif [[ -f "${check_config_d}" ]] && [[ -r "${check_config_d}" ]]; then
152         echo "# INFO: Using additional config file ${check_config_d}"
153         # shellcheck disable=SC1090
154         . "${check_config_d}"
155       else
156         _exiterr "Specified additional config ${check_config_d} is not readable or not a file at all." >&2
157       fi
158    done
159   fi
160
161   # Remove slash from end of BASEDIR. Mostly for cleaner outputs, doesn't change functionality.
162   BASEDIR="${BASEDIR%%/}"
163
164   # Check BASEDIR and set default variables
165   [[ -d "${BASEDIR}" ]] || _exiterr "BASEDIR does not exist: ${BASEDIR}"
166
167   CAHASH="$(echo "${CA}" | urlbase64)"
168   [[ -z "${ACCOUNTDIR}" ]] && ACCOUNTDIR="${BASEDIR}/accounts"
169   mkdir -p "${ACCOUNTDIR}/${CAHASH}"
170   [[ -f "${ACCOUNTDIR}/${CAHASH}/config" ]] && . "${ACCOUNTDIR}/${CAHASH}/config"
171   ACCOUNT_KEY="${ACCOUNTDIR}/${CAHASH}/account_key.pem"
172   ACCOUNT_KEY_JSON="${ACCOUNTDIR}/${CAHASH}/registration_info.json"
173
174   if [[ -f "${BASEDIR}/private_key.pem" ]] && [[ ! -f "${ACCOUNT_KEY}" ]]; then
175     echo "! Moving private_key.pem to ${ACCOUNT_KEY}"
176     mv "${BASEDIR}/private_key.pem" "${ACCOUNT_KEY}"
177   fi
178   if [[ -f "${BASEDIR}/private_key.json" ]] && [[ ! -f "${ACCOUNT_KEY_JSON}" ]]; then
179     echo "! Moving private_key.json to ${ACCOUNT_KEY_JSON}"
180     mv "${BASEDIR}/private_key.json" "${ACCOUNT_KEY_JSON}"
181   fi
182
183   [[ -z "${CERTDIR}" ]] && CERTDIR="${BASEDIR}/certs"
184   [[ -z "${DOMAINS_TXT}" ]] && DOMAINS_TXT="${BASEDIR}/domains.txt"
185   [[ -z "${WELLKNOWN}" ]] && WELLKNOWN="/var/www/dehydrated"
186   [[ -z "${LOCKFILE}" ]] && LOCKFILE="${BASEDIR}/lock"
187   [[ -n "${PARAM_NO_LOCK:-}" ]] && LOCKFILE=""
188
189   [[ -n "${PARAM_HOOK:-}" ]] && HOOK="${PARAM_HOOK}"
190   [[ -n "${PARAM_CERTDIR:-}" ]] && CERTDIR="${PARAM_CERTDIR}"
191   [[ -n "${PARAM_CHALLENGETYPE:-}" ]] && CHALLENGETYPE="${PARAM_CHALLENGETYPE}"
192   [[ -n "${PARAM_KEY_ALGO:-}" ]] && KEY_ALGO="${PARAM_KEY_ALGO}"
193   [[ -n "${PARAM_OCSP_MUST_STAPLE:-}" ]] && OCSP_MUST_STAPLE="${PARAM_OCSP_MUST_STAPLE}"
194   [[ -n "${PARAM_IP_VERSION:-}" ]] && IP_VERSION="${PARAM_IP_VERSION}"
195
196   verify_config
197   store_configvars
198 }
199
200 # Initialize system
201 init_system() {
202   load_config
203
204   # Lockfile handling (prevents concurrent access)
205   if [[ -n "${LOCKFILE}" ]]; then
206     LOCKDIR="$(dirname "${LOCKFILE}")"
207     [[ -w "${LOCKDIR}" ]] || _exiterr "Directory ${LOCKDIR} for LOCKFILE ${LOCKFILE} is not writable, aborting."
208     ( set -C; date > "${LOCKFILE}" ) 2>/dev/null || _exiterr "Lock file '${LOCKFILE}' present, aborting."
209     remove_lock() { rm -f "${LOCKFILE}"; }
210     trap 'remove_lock' EXIT
211   fi
212
213   # Get CA URLs
214   CA_DIRECTORY="$(http_request get "${CA}")"
215   CA_NEW_CERT="$(printf "%s" "${CA_DIRECTORY}" | get_json_string_value new-cert)" &&
216   CA_NEW_AUTHZ="$(printf "%s" "${CA_DIRECTORY}" | get_json_string_value new-authz)" &&
217   CA_NEW_REG="$(printf "%s" "${CA_DIRECTORY}" | get_json_string_value new-reg)" &&
218   # shellcheck disable=SC2015
219   CA_REVOKE_CERT="$(printf "%s" "${CA_DIRECTORY}" | get_json_string_value revoke-cert)" ||
220   _exiterr "Problem retrieving ACME/CA-URLs, check if your configured CA points to the directory entrypoint."
221
222   # Export some environment variables to be used in hook script
223   export WELLKNOWN BASEDIR CERTDIR CONFIG
224
225   # Checking for private key ...
226   register_new_key="no"
227   if [[ -n "${PARAM_ACCOUNT_KEY:-}" ]]; then
228     # a private key was specified from the command line so use it for this run
229     echo "Using private key ${PARAM_ACCOUNT_KEY} instead of account key"
230     ACCOUNT_KEY="${PARAM_ACCOUNT_KEY}"
231     ACCOUNT_KEY_JSON="${PARAM_ACCOUNT_KEY}.json"
232   else
233     # Check if private account key exists, if it doesn't exist yet generate a new one (rsa key)
234     if [[ ! -e "${ACCOUNT_KEY}" ]]; then
235       echo "+ Generating account key..."
236       _openssl genrsa -out "${ACCOUNT_KEY}" "${KEYSIZE}"
237       register_new_key="yes"
238     fi
239   fi
240   openssl rsa -in "${ACCOUNT_KEY}" -check 2>/dev/null > /dev/null || _exiterr "Account key is not valid, can not continue."
241
242   # Get public components from private key and calculate thumbprint
243   pubExponent64="$(printf '%x' "$(openssl rsa -in "${ACCOUNT_KEY}" -noout -text | awk '/publicExponent/ {print $2}')" | hex2bin | urlbase64)"
244   pubMod64="$(openssl rsa -in "${ACCOUNT_KEY}" -noout -modulus | cut -d'=' -f2 | hex2bin | urlbase64)"
245
246   thumbprint="$(printf '{"e":"%s","kty":"RSA","n":"%s"}' "${pubExponent64}" "${pubMod64}" | openssl dgst -sha256 -binary | urlbase64)"
247
248   # If we generated a new private key in the step above we have to register it with the acme-server
249   if [[ "${register_new_key}" = "yes" ]]; then
250     echo "+ Registering account key with ACME server..."
251     [[ ! -z "${CA_NEW_REG}" ]] || _exiterr "Certificate authority doesn't allow registrations."
252     # If an email for the contact has been provided then adding it to the registration request
253     FAILED=false
254     if [[ -n "${CONTACT_EMAIL}" ]]; then
255       (signed_request "${CA_NEW_REG}" '{"resource": "new-reg", "contact":["mailto:'"${CONTACT_EMAIL}"'"], "agreement": "'"$LICENSE"'"}' > "${ACCOUNT_KEY_JSON}") || FAILED=true
256     else
257       (signed_request "${CA_NEW_REG}" '{"resource": "new-reg", "agreement": "'"$LICENSE"'"}' > "${ACCOUNT_KEY_JSON}") || FAILED=true
258     fi
259     if [[ "${FAILED}" = "true" ]]; then
260       echo
261       echo
262       echo "Error registering account key. See message above for more information."
263       rm "${ACCOUNT_KEY}" "${ACCOUNT_KEY_JSON}"
264       exit 1
265     fi
266   fi
267
268 }
269
270 # Different sed version for different os types...
271 _sed() {
272   if [[ "${OSTYPE}" = "Linux" ]]; then
273     sed -r "${@}"
274   else
275     sed -E "${@}"
276   fi
277 }
278
279 # Print error message and exit with error
280 _exiterr() {
281   echo "ERROR: ${1}" >&2
282   exit 1
283 }
284
285 # Remove newlines and whitespace from json
286 clean_json() {
287   tr -d '\r\n' | _sed -e 's/ +/ /g' -e 's/\{ /{/g' -e 's/ \}/}/g' -e 's/\[ /[/g' -e 's/ \]/]/g'
288 }
289
290 # Encode data as url-safe formatted base64
291 urlbase64() {
292   # urlbase64: base64 encoded string with '+' replaced with '-' and '/' replaced with '_'
293   openssl base64 -e | tr -d '\n\r' | _sed -e 's:=*$::g' -e 'y:+/:-_:'
294 }
295
296 # Convert hex string to binary data
297 hex2bin() {
298   # Remove spaces, add leading zero, escape as hex string and parse with printf
299   printf -- "$(cat | _sed -e 's/[[:space:]]//g' -e 's/^(.(.{2})*)$/0\1/' -e 's/(.{2})/\\x\1/g')"
300 }
301
302 # Get string value from json dictionary
303 get_json_string_value() {
304   local filter
305   filter=$(printf 's/.*"%s": *"\([^"]*\)".*/\\1/p' "$1")
306   sed -n "${filter}"
307 }
308
309 rm_json_arrays() {
310   local filter
311   filter='s/\[[^][]*\]/null/g'
312   # remove three levels of nested arrays
313   sed -e "${filter}" -e "${filter}" -e "${filter}"
314 }
315
316 # OpenSSL writes to stderr/stdout even when there are no errors. So just
317 # display the output if the exit code was != 0 to simplify debugging.
318 _openssl() {
319   set +e
320   out="$(openssl "${@}" 2>&1)"
321   res=$?
322   set -e
323   if [[ ${res} -ne 0 ]]; then
324     echo "  + ERROR: failed to run $* (Exitcode: ${res})" >&2
325     echo >&2
326     echo "Details:" >&2
327     echo "${out}" >&2
328     echo >&2
329     exit ${res}
330   fi
331 }
332
333 # Send http(s) request with specified method
334 http_request() {
335   tempcont="$(_mktemp)"
336
337   if [[ -n "${IP_VERSION:-}" ]]; then
338       ip_version="-${IP_VERSION}"
339   fi
340
341   set +e
342   if [[ "${1}" = "head" ]]; then
343     statuscode="$(curl ${ip_version:-} -s -w "%{http_code}" -o "${tempcont}" "${2}" -I)"
344     curlret="${?}"
345   elif [[ "${1}" = "get" ]]; then
346     statuscode="$(curl ${ip_version:-} -s -w "%{http_code}" -o "${tempcont}" "${2}")"
347     curlret="${?}"
348   elif [[ "${1}" = "post" ]]; then
349     statuscode="$(curl ${ip_version:-} -s -w "%{http_code}" -o "${tempcont}" "${2}" -d "${3}")"
350     curlret="${?}"
351   else
352     set -e
353     _exiterr "Unknown request method: ${1}"
354   fi
355   set -e
356
357   if [[ ! "${curlret}" = "0" ]]; then
358     _exiterr "Problem connecting to server (${1} for ${2}; curl returned with ${curlret})"
359   fi
360
361   if [[ ! "${statuscode:0:1}" = "2" ]]; then
362     echo "  + ERROR: An error occurred while sending ${1}-request to ${2} (Status ${statuscode})" >&2
363     echo >&2
364     echo "Details:" >&2
365     cat "${tempcont}" >&2
366     echo >&2
367     echo >&2
368     rm -f "${tempcont}"
369
370     # Wait for hook script to clean the challenge if used
371     if [[ -n "${HOOK}" ]] && [[ "${HOOK_CHAIN}" != "yes" ]] && [[ -n "${challenge_token:+set}" ]]; then
372       "${HOOK}" "clean_challenge" '' "${challenge_token}" "${keyauth}"
373     fi
374
375     # remove temporary domains.txt file if used
376     [[ -n "${PARAM_DOMAIN:-}" && -n "${DOMAINS_TXT:-}" ]] && rm "${DOMAINS_TXT}"
377     exit 1
378   fi
379
380   cat "${tempcont}"
381   rm -f "${tempcont}"
382 }
383
384 # Send signed request
385 signed_request() {
386   # Encode payload as urlbase64
387   payload64="$(printf '%s' "${2}" | urlbase64)"
388
389   # Retrieve nonce from acme-server
390   nonce="$(http_request head "${CA}" | grep Replay-Nonce: | awk -F ': ' '{print $2}' | tr -d '\n\r')"
391
392   # Build header with just our public key and algorithm information
393   header='{"alg": "RS256", "jwk": {"e": "'"${pubExponent64}"'", "kty": "RSA", "n": "'"${pubMod64}"'"}}'
394
395   # Build another header which also contains the previously received nonce and encode it as urlbase64
396   protected='{"alg": "RS256", "jwk": {"e": "'"${pubExponent64}"'", "kty": "RSA", "n": "'"${pubMod64}"'"}, "nonce": "'"${nonce}"'"}'
397   protected64="$(printf '%s' "${protected}" | urlbase64)"
398
399   # Sign header with nonce and our payload with our private key and encode signature as urlbase64
400   signed64="$(printf '%s' "${protected64}.${payload64}" | openssl dgst -sha256 -sign "${ACCOUNT_KEY}" | urlbase64)"
401
402   # Send header + extended header + payload + signature to the acme-server
403   data='{"header": '"${header}"', "protected": "'"${protected64}"'", "payload": "'"${payload64}"'", "signature": "'"${signed64}"'"}'
404
405   http_request post "${1}" "${data}"
406 }
407
408 # Extracts all subject names from a CSR
409 # Outputs either the CN, or the SANs, one per line
410 extract_altnames() {
411   csr="${1}" # the CSR itself (not a file)
412
413   if ! <<<"${csr}" openssl req -verify -noout 2>/dev/null; then
414     _exiterr "Certificate signing request isn't valid"
415   fi
416
417   reqtext="$( <<<"${csr}" openssl req -noout -text )"
418   if <<<"${reqtext}" grep -q '^[[:space:]]*X509v3 Subject Alternative Name:[[:space:]]*$'; then
419     # SANs used, extract these
420     altnames="$( <<<"${reqtext}" grep -A1 '^[[:space:]]*X509v3 Subject Alternative Name:[[:space:]]*$' | tail -n1 )"
421     # split to one per line:
422     # shellcheck disable=SC1003
423     altnames="$( <<<"${altnames}" _sed -e 's/^[[:space:]]*//; s/, /\'$'\n''/g' )"
424     # we can only get DNS: ones signed
425     if grep -qv '^DNS:' <<<"${altnames}"; then
426       _exiterr "Certificate signing request contains non-DNS Subject Alternative Names"
427     fi
428     # strip away the DNS: prefix
429     altnames="$( <<<"${altnames}" _sed -e 's/^DNS://' )"
430     echo "${altnames}"
431
432   else
433     # No SANs, extract CN
434     altnames="$( <<<"${reqtext}" grep '^[[:space:]]*Subject:' | _sed -e 's/.* CN=([^ /,]*).*/\1/' )"
435     echo "${altnames}"
436   fi
437 }
438
439 # Create certificate for domain(s) and outputs it FD 3
440 sign_csr() {
441   csr="${1}" # the CSR itself (not a file)
442
443   if { true >&3; } 2>/dev/null; then
444     : # fd 3 looks OK
445   else
446     _exiterr "sign_csr: FD 3 not open"
447   fi
448
449   shift 1 || true
450   altnames="${*:-}"
451   if [ -z "${altnames}" ]; then
452     altnames="$( extract_altnames "${csr}" )"
453   fi
454
455   if [[ -z "${CA_NEW_AUTHZ}" ]] || [[ -z "${CA_NEW_CERT}" ]]; then
456     _exiterr "Certificate authority doesn't allow certificate signing"
457   fi
458
459   local idx=0
460   if [[ -n "${ZSH_VERSION:-}" ]]; then
461     local -A challenge_altnames challenge_uris challenge_tokens keyauths deploy_args
462   else
463     local -a challenge_altnames challenge_uris challenge_tokens keyauths deploy_args
464   fi
465
466   # Request challenges
467   for altname in ${altnames}; do
468     # Ask the acme-server for new challenge token and extract them from the resulting json block
469     echo " + Requesting challenge for ${altname}..."
470     response="$(signed_request "${CA_NEW_AUTHZ}" '{"resource": "new-authz", "identifier": {"type": "dns", "value": "'"${altname}"'"}}' | clean_json)"
471
472     challenge_status="$(printf '%s' "${response}" | rm_json_arrays | get_json_string_value status)"
473     if [ "${challenge_status}" = "valid" ]; then
474        echo " + Already validated"
475        continue
476     fi
477
478     challenges="$(printf '%s\n' "${response}" | sed -n 's/.*\("challenges":[^\[]*\[[^]]*]\).*/\1/p')"
479     repl=$'\n''{' # fix syntax highlighting in Vim
480     challenge="$(printf "%s" "${challenges//\{/${repl}}" | grep \""${CHALLENGETYPE}"\")"
481     challenge_token="$(printf '%s' "${challenge}" | get_json_string_value token | _sed 's/[^A-Za-z0-9_\-]/_/g')"
482     challenge_uri="$(printf '%s' "${challenge}" | get_json_string_value uri)"
483
484     if [[ -z "${challenge_token}" ]] || [[ -z "${challenge_uri}" ]]; then
485       _exiterr "Can't retrieve challenges (${response})"
486     fi
487
488     # Challenge response consists of the challenge token and the thumbprint of our public certificate
489     keyauth="${challenge_token}.${thumbprint}"
490
491     case "${CHALLENGETYPE}" in
492       "http-01")
493         # Store challenge response in well-known location and make world-readable (so that a webserver can access it)
494         printf '%s' "${keyauth}" > "${WELLKNOWN}/${challenge_token}"
495         chmod a+r "${WELLKNOWN}/${challenge_token}"
496         keyauth_hook="${keyauth}"
497         ;;
498       "dns-01")
499         # Generate DNS entry content for dns-01 validation
500         keyauth_hook="$(printf '%s' "${keyauth}" | openssl dgst -sha256 -binary | urlbase64)"
501         ;;
502     esac
503
504     challenge_altnames[${idx}]="${altname}"
505     challenge_uris[${idx}]="${challenge_uri}"
506     keyauths[${idx}]="${keyauth}"
507     challenge_tokens[${idx}]="${challenge_token}"
508     # Note: assumes args will never have spaces!
509     deploy_args[${idx}]="${altname} ${challenge_token} ${keyauth_hook}"
510     idx=$((idx+1))
511   done
512
513   # Wait for hook script to deploy the challenges if used
514   if [ ${#deploy_args[@]} -ne 0 ]; then
515     # shellcheck disable=SC2068
516     [[ -n "${HOOK}" ]] && [[ "${HOOK_CHAIN}" = "yes" ]] && "${HOOK}" "deploy_challenge" ${deploy_args[@]}
517   fi
518
519   # Respond to challenges
520   reqstatus="valid"
521   idx=0
522   for altname in "${challenge_altnames[@]:0}"; do
523     challenge_token="${challenge_tokens[${idx}]}"
524     keyauth="${keyauths[${idx}]}"
525
526     # Wait for hook script to deploy the challenge if used
527     # shellcheck disable=SC2086
528     [[ -n "${HOOK}" ]] && [[ "${HOOK_CHAIN}" != "yes" ]] && "${HOOK}" "deploy_challenge" ${deploy_args[${idx}]}
529
530     # Ask the acme-server to verify our challenge and wait until it is no longer pending
531     echo " + Responding to challenge for ${altname}..."
532     result="$(signed_request "${challenge_uris[${idx}]}" '{"resource": "challenge", "keyAuthorization": "'"${keyauth}"'"}' | clean_json)"
533
534     reqstatus="$(printf '%s\n' "${result}" | get_json_string_value status)"
535
536     while [[ "${reqstatus}" = "pending" ]]; do
537       sleep 1
538       result="$(http_request get "${challenge_uris[${idx}]}")"
539       reqstatus="$(printf '%s\n' "${result}" | get_json_string_value status)"
540     done
541
542     [[ "${CHALLENGETYPE}" = "http-01" ]] && rm -f "${WELLKNOWN}/${challenge_token}"
543
544     # Wait for hook script to clean the challenge if used
545     if [[ -n "${HOOK}" ]] && [[ "${HOOK_CHAIN}" != "yes" ]] && [[ -n "${challenge_token}" ]]; then
546       # shellcheck disable=SC2086
547       "${HOOK}" "clean_challenge" ${deploy_args[${idx}]}
548     fi
549     idx=$((idx+1))
550
551     if [[ "${reqstatus}" = "valid" ]]; then
552       echo " + Challenge is valid!"
553     else
554       break
555     fi
556   done
557
558   # Wait for hook script to clean the challenges if used
559   # shellcheck disable=SC2068
560   [[ -n "${HOOK}" ]] && [[ "${HOOK_CHAIN}" = "yes" ]] && "${HOOK}" "clean_challenge" ${deploy_args[@]}
561
562   if [[ "${reqstatus}" != "valid" ]]; then
563     # Clean up any remaining challenge_tokens if we stopped early
564     if [[ "${CHALLENGETYPE}" = "http-01" ]]; then
565       while [ ${idx} -lt ${#challenge_tokens[@]} ]; do
566         rm -f "${WELLKNOWN}/${challenge_tokens[${idx}]}"
567         idx=$((idx+1))
568       done
569     fi
570
571     _exiterr "Challenge is invalid! (returned: ${reqstatus}) (result: ${result})"
572   fi
573
574   # Finally request certificate from the acme-server and store it in cert-${timestamp}.pem and link from cert.pem
575   echo " + Requesting certificate..."
576   csr64="$( <<<"${csr}" openssl req -outform DER | urlbase64)"
577   crt64="$(signed_request "${CA_NEW_CERT}" '{"resource": "new-cert", "csr": "'"${csr64}"'"}' | openssl base64 -e)"
578   crt="$( printf -- '-----BEGIN CERTIFICATE-----\n%s\n-----END CERTIFICATE-----\n' "${crt64}" )"
579
580   # Try to load the certificate to detect corruption
581   echo " + Checking certificate..."
582   _openssl x509 -text <<<"${crt}"
583
584   echo "${crt}" >&3
585
586   unset challenge_token
587   echo " + Done!"
588 }
589
590 # Create certificate for domain(s)
591 sign_domain() {
592   domain="${1}"
593   altnames="${*}"
594   timestamp="$(date +%s)"
595
596   echo " + Signing domains..."
597   if [[ -z "${CA_NEW_AUTHZ}" ]] || [[ -z "${CA_NEW_CERT}" ]]; then
598     _exiterr "Certificate authority doesn't allow certificate signing"
599   fi
600
601   # If there is no existing certificate directory => make it
602   if [[ ! -e "${CERTDIR}/${domain}" ]]; then
603     echo " + Creating new directory ${CERTDIR}/${domain} ..."
604     mkdir -p "${CERTDIR}/${domain}" || _exiterr "Unable to create directory ${CERTDIR}/${domain}"
605   fi
606
607   privkey="privkey.pem"
608   # generate a new private key if we need or want one
609   if [[ ! -r "${CERTDIR}/${domain}/privkey.pem" ]] || [[ "${PRIVATE_KEY_RENEW}" = "yes" ]]; then
610     echo " + Generating private key..."
611     privkey="privkey-${timestamp}.pem"
612     case "${KEY_ALGO}" in
613       rsa) _openssl genrsa -out "${CERTDIR}/${domain}/privkey-${timestamp}.pem" "${KEYSIZE}";;
614       prime256v1|secp384r1) _openssl ecparam -genkey -name "${KEY_ALGO}" -out "${CERTDIR}/${domain}/privkey-${timestamp}.pem";;
615     esac
616   fi
617   # move rolloverkey into position (if any)
618   if [[ -r "${CERTDIR}/${domain}/privkey.pem" && -r "${CERTDIR}/${domain}/privkey.roll.pem" && "${PRIVATE_KEY_RENEW}" = "yes" && "${PRIVATE_KEY_ROLLOVER}" = "yes" ]]; then
619     echo " + Moving Rolloverkey into position....  "
620     mv "${CERTDIR}/${domain}/privkey.roll.pem" "${CERTDIR}/${domain}/privkey-tmp.pem"
621     mv "${CERTDIR}/${domain}/privkey-${timestamp}.pem" "${CERTDIR}/${domain}/privkey.roll.pem"
622     mv "${CERTDIR}/${domain}/privkey-tmp.pem" "${CERTDIR}/${domain}/privkey-${timestamp}.pem"
623   fi
624   # generate a new private rollover key if we need or want one
625   if [[ ! -r "${CERTDIR}/${domain}/privkey.roll.pem" && "${PRIVATE_KEY_ROLLOVER}" = "yes" && "${PRIVATE_KEY_RENEW}" = "yes" ]]; then
626     echo " + Generating private rollover key..."
627     case "${KEY_ALGO}" in
628       rsa) _openssl genrsa -out "${CERTDIR}/${domain}/privkey.roll.pem" "${KEYSIZE}";;
629       prime256v1|secp384r1) _openssl ecparam -genkey -name "${KEY_ALGO}" -out "${CERTDIR}/${domain}/privkey.roll.pem";;
630     esac
631   fi
632   # delete rolloverkeys if disabled
633   if [[ -r "${CERTDIR}/${domain}/privkey.roll.pem" && ! "${PRIVATE_KEY_ROLLOVER}" = "yes" ]]; then
634     echo " + Removing Rolloverkey (feature disabled)..."
635     rm -f "${CERTDIR}/${domain}/privkey.roll.pem"
636   fi
637
638   # Generate signing request config and the actual signing request
639   echo " + Generating signing request..."
640   SAN=""
641   for altname in ${altnames}; do
642     SAN+="DNS:${altname}, "
643   done
644   SAN="${SAN%%, }"
645   local tmp_openssl_cnf
646   tmp_openssl_cnf="$(_mktemp)"
647   cat "${OPENSSL_CNF}" > "${tmp_openssl_cnf}"
648   printf "[SAN]\nsubjectAltName=%s" "${SAN}" >> "${tmp_openssl_cnf}"
649   if [ "${OCSP_MUST_STAPLE}" = "yes" ]; then
650     printf "\n1.3.6.1.5.5.7.1.24=DER:30:03:02:01:05" >> "${tmp_openssl_cnf}"
651   fi
652   openssl req -new -sha256 -key "${CERTDIR}/${domain}/${privkey}" -out "${CERTDIR}/${domain}/cert-${timestamp}.csr" -subj "/CN=${domain}/" -reqexts SAN -config "${tmp_openssl_cnf}"
653   rm -f "${tmp_openssl_cnf}"
654
655   crt_path="${CERTDIR}/${domain}/cert-${timestamp}.pem"
656   # shellcheck disable=SC2086
657   sign_csr "$(< "${CERTDIR}/${domain}/cert-${timestamp}.csr" )" ${altnames} 3>"${crt_path}"
658
659   # Create fullchain.pem
660   echo " + Creating fullchain.pem..."
661   cat "${crt_path}" > "${CERTDIR}/${domain}/fullchain-${timestamp}.pem"
662   tmpchain="$(_mktemp)"
663   http_request get "$(openssl x509 -in "${CERTDIR}/${domain}/cert-${timestamp}.pem" -noout -text | grep 'CA Issuers - URI:' | cut -d':' -f2-)" > "${tmpchain}"
664   if grep -q "BEGIN CERTIFICATE" "${tmpchain}"; then
665     mv "${tmpchain}" "${CERTDIR}/${domain}/chain-${timestamp}.pem"
666   else
667     openssl x509 -in "${tmpchain}" -inform DER -out "${CERTDIR}/${domain}/chain-${timestamp}.pem" -outform PEM
668     rm "${tmpchain}"
669   fi
670   cat "${CERTDIR}/${domain}/chain-${timestamp}.pem" >> "${CERTDIR}/${domain}/fullchain-${timestamp}.pem"
671
672   # Update symlinks
673   [[ "${privkey}" = "privkey.pem" ]] || ln -sf "privkey-${timestamp}.pem" "${CERTDIR}/${domain}/privkey.pem"
674
675   ln -sf "chain-${timestamp}.pem" "${CERTDIR}/${domain}/chain.pem"
676   ln -sf "fullchain-${timestamp}.pem" "${CERTDIR}/${domain}/fullchain.pem"
677   ln -sf "cert-${timestamp}.csr" "${CERTDIR}/${domain}/cert.csr"
678   ln -sf "cert-${timestamp}.pem" "${CERTDIR}/${domain}/cert.pem"
679
680   # Wait for hook script to clean the challenge and to deploy cert if used
681   export KEY_ALGO
682   [[ -n "${HOOK}" ]] && "${HOOK}" "deploy_cert" "${domain}" "${CERTDIR}/${domain}/privkey.pem" "${CERTDIR}/${domain}/cert.pem" "${CERTDIR}/${domain}/fullchain.pem" "${CERTDIR}/${domain}/chain.pem" "${timestamp}"
683
684   unset challenge_token
685   echo " + Done!"
686 }
687
688 # Usage: --cron (-c)
689 # Description: Sign/renew non-existant/changed/expiring certificates.
690 command_sign_domains() {
691   init_system
692
693   if [[ -n "${PARAM_DOMAIN:-}" ]]; then
694     DOMAINS_TXT="$(_mktemp)"
695     printf -- "${PARAM_DOMAIN}" > "${DOMAINS_TXT}"
696   elif [[ -e "${DOMAINS_TXT}" ]]; then
697     if [[ ! -r "${DOMAINS_TXT}" ]]; then
698       _exiterr "domains.txt found but not readable"
699     fi
700   else
701     _exiterr "domains.txt not found and --domain not given"
702   fi
703
704   # Generate certificates for all domains found in domains.txt. Check if existing certificate are about to expire
705   ORIGIFS="${IFS}"
706   IFS=$'\n'
707   for line in $(<"${DOMAINS_TXT}" tr -d '\r' | tr '[:upper:]' '[:lower:]' | _sed -e 's/^[[:space:]]*//g' -e 's/[[:space:]]*$//g' -e 's/[[:space:]]+/ /g' | (grep -vE '^(#|$)' || true)); do
708     reset_configvars
709     IFS="${ORIGIFS}"
710     domain="$(printf '%s\n' "${line}" | cut -d' ' -f1)"
711     morenames="$(printf '%s\n' "${line}" | cut -s -d' ' -f2-)"
712     cert="${CERTDIR}/${domain}/cert.pem"
713
714     force_renew="${PARAM_FORCE:-no}"
715
716     if [[ -z "${morenames}" ]];then
717       echo "Processing ${domain}"
718     else
719       echo "Processing ${domain} with alternative names: ${morenames}"
720     fi
721
722     # read cert config
723     # for now this loads the certificate specific config in a subshell and parses a diff of set variables.
724     # we could just source the config file but i decided to go this way to protect people from accidentally overriding
725     # variables used internally by this script itself.
726     if [[ -n "${DOMAINS_D}" ]]; then
727       certconfig="${DOMAINS_D}/${domain}"
728     else
729       certconfig="${CERTDIR}/${domain}/config"
730     fi
731
732     if [ -f "${certconfig}" ]; then
733       echo " + Using certificate specific config file!"
734       ORIGIFS="${IFS}"
735       IFS=$'\n'
736       for cfgline in $(
737         beforevars="$(_mktemp)"
738         aftervars="$(_mktemp)"
739         set > "${beforevars}"
740         # shellcheck disable=SC1090
741         . "${certconfig}"
742         set > "${aftervars}"
743         diff -u "${beforevars}" "${aftervars}" | grep -E '^\+[^+]'
744         rm "${beforevars}"
745         rm "${aftervars}"
746       ); do
747         config_var="$(echo "${cfgline:1}" | cut -d'=' -f1)"
748         config_value="$(echo "${cfgline:1}" | cut -d'=' -f2-)"
749         case "${config_var}" in
750           KEY_ALGO|OCSP_MUST_STAPLE|PRIVATE_KEY_RENEW|PRIVATE_KEY_ROLLOVER|KEYSIZE|CHALLENGETYPE|HOOK|WELLKNOWN|HOOK_CHAIN|OPENSSL_CNF|RENEW_DAYS)
751             echo "   + ${config_var} = ${config_value}"
752             declare -- "${config_var}=${config_value}"
753             ;;
754           _) ;;
755           *) echo "   ! Setting ${config_var} on a per-certificate base is not (yet) supported"
756         esac
757       done
758       IFS="${ORIGIFS}"
759     fi
760     verify_config
761
762     if [[ -e "${cert}" ]]; then
763       printf " + Checking domain name(s) of existing cert..."
764
765       certnames="$(openssl x509 -in "${cert}" -text -noout | grep DNS: | _sed 's/DNS://g' | tr -d ' ' | tr ',' '\n' | sort -u | tr '\n' ' ' | _sed 's/ $//')"
766       givennames="$(echo "${domain}" "${morenames}"| tr ' ' '\n' | sort -u | tr '\n' ' ' | _sed 's/ $//' | _sed 's/^ //')"
767
768       if [[ "${certnames}" = "${givennames}" ]]; then
769         echo " unchanged."
770       else
771         echo " changed!"
772         echo " + Domain name(s) are not matching!"
773         echo " + Names in old certificate: ${certnames}"
774         echo " + Configured names: ${givennames}"
775         echo " + Forcing renew."
776         force_renew="yes"
777       fi
778     fi
779
780     if [[ -e "${cert}" ]]; then
781       echo " + Checking expire date of existing cert..."
782       valid="$(openssl x509 -enddate -noout -in "${cert}" | cut -d= -f2- )"
783
784       printf " + Valid till %s " "${valid}"
785       if openssl x509 -checkend $((RENEW_DAYS * 86400)) -noout -in "${cert}"; then
786         printf "(Longer than %d days). " "${RENEW_DAYS}"
787         if [[ "${force_renew}" = "yes" ]]; then
788           echo "Ignoring because renew was forced!"
789         else
790           # Certificate-Names unchanged and cert is still valid
791           echo "Skipping renew!"
792           [[ -n "${HOOK}" ]] && "${HOOK}" "unchanged_cert" "${domain}" "${CERTDIR}/${domain}/privkey.pem" "${CERTDIR}/${domain}/cert.pem" "${CERTDIR}/${domain}/fullchain.pem" "${CERTDIR}/${domain}/chain.pem"
793           continue
794         fi
795       else
796         echo "(Less than ${RENEW_DAYS} days). Renewing!"
797       fi
798     fi
799
800     # shellcheck disable=SC2086
801     if [[ "${PARAM_KEEP_GOING:-}" = "yes" ]]; then
802       sign_domain ${line} &
803       wait $! || true
804     else
805       sign_domain ${line}
806     fi
807   done
808
809   # remove temporary domains.txt file if used
810   [[ -n "${PARAM_DOMAIN:-}" ]] && rm -f "${DOMAINS_TXT}"
811
812   exit 0
813 }
814
815 # Usage: --signcsr (-s) path/to/csr.pem
816 # Description: Sign a given CSR, output CRT on stdout (advanced usage)
817 command_sign_csr() {
818   # redirect stdout to stderr
819   # leave stdout over at fd 3 to output the cert
820   exec 3>&1 1>&2
821
822   init_system
823
824   csrfile="${1}"
825   if [ ! -r "${csrfile}" ]; then
826     _exiterr "Could not read certificate signing request ${csrfile}"
827   fi
828
829   # gen cert
830   certfile="$(_mktemp)"
831   sign_csr "$(< "${csrfile}" )" 3> "${certfile}"
832
833   # print cert
834   echo "# CERT #" >&3
835   cat "${certfile}" >&3
836   echo >&3
837
838   # print chain
839   if [ -n "${PARAM_FULL_CHAIN:-}" ]; then
840     # get and convert ca cert
841     chainfile="$(_mktemp)"
842     tmpchain="$(_mktemp)"
843     http_request get "$(openssl x509 -in "${certfile}" -noout -text | grep 'CA Issuers - URI:' | cut -d':' -f2-)" > "${tmpchain}"
844     if grep -q "BEGIN CERTIFICATE" "${tmpchain}"; then
845       mv "${tmpchain}" "${chainfile}"
846     else
847       openssl x509 -in "${tmpchain}" -inform DER -out "${chainfile}" -outform PEM
848       rm "${tmpchain}"
849     fi
850
851     echo "# CHAIN #" >&3
852     cat "${chainfile}" >&3
853
854     rm "${chainfile}"
855   fi
856
857   # cleanup
858   rm "${certfile}"
859
860   exit 0
861 }
862
863 # Usage: --revoke (-r) path/to/cert.pem
864 # Description: Revoke specified certificate
865 command_revoke() {
866   init_system
867
868   [[ -n "${CA_REVOKE_CERT}" ]] || _exiterr "Certificate authority doesn't allow certificate revocation."
869
870   cert="${1}"
871   if [[ -L "${cert}" ]]; then
872     # follow symlink and use real certificate name (so we move the real file and not the symlink at the end)
873     local link_target
874     link_target="$(readlink -n "${cert}")"
875     if [[ "${link_target}" =~ ^/ ]]; then
876       cert="${link_target}"
877     else
878       cert="$(dirname "${cert}")/${link_target}"
879     fi
880   fi
881   [[ -f "${cert}" ]] || _exiterr "Could not find certificate ${cert}"
882
883   echo "Revoking ${cert}"
884
885   cert64="$(openssl x509 -in "${cert}" -inform PEM -outform DER | urlbase64)"
886   response="$(signed_request "${CA_REVOKE_CERT}" '{"resource": "revoke-cert", "certificate": "'"${cert64}"'"}' | clean_json)"
887   # if there is a problem with our revoke request _request (via signed_request) will report this and "exit 1" out
888   # so if we are here, it is safe to assume the request was successful
889   echo " + Done."
890   echo " + Renaming certificate to ${cert}-revoked"
891   mv -f "${cert}" "${cert}-revoked"
892 }
893
894 # Usage: --cleanup (-gc)
895 # Description: Move unused certificate files to archive directory
896 command_cleanup() {
897   load_config
898
899   # Create global archive directory if not existant
900   if [[ ! -e "${BASEDIR}/archive" ]]; then
901     mkdir "${BASEDIR}/archive"
902   fi
903
904   # Loop over all certificate directories
905   for certdir in "${CERTDIR}/"*; do
906     # Skip if entry is not a folder
907     [[ -d "${certdir}" ]] || continue
908
909     # Get certificate name
910     certname="$(basename "${certdir}")"
911
912     # Create certitifaces archive directory if not existant
913     archivedir="${BASEDIR}/archive/${certname}"
914     if [[ ! -e "${archivedir}" ]]; then
915       mkdir "${archivedir}"
916     fi
917
918     # Loop over file-types (certificates, keys, signing-requests, ...)
919     for filetype in cert.csr cert.pem chain.pem fullchain.pem privkey.pem; do
920       # Skip if symlink is broken
921       [[ -r "${certdir}/${filetype}" ]] || continue
922
923       # Look up current file in use
924       current="$(basename "$(readlink "${certdir}/${filetype}")")"
925
926       # Split filetype into name and extension
927       filebase="$(echo "${filetype}" | cut -d. -f1)"
928       fileext="$(echo "${filetype}" | cut -d. -f2)"
929
930       # Loop over all files of this type
931       for file in "${certdir}/${filebase}-"*".${fileext}"; do
932         # Handle case where no files match the wildcard
933         [[ -f "${file}" ]] || break
934
935         # Check if current file is in use, if unused move to archive directory
936         filename="$(basename "${file}")"
937         if [[ ! "${filename}" = "${current}" ]]; then
938           echo "Moving unused file to archive directory: ${certname}/${filename}"
939           mv "${certdir}/${filename}" "${archivedir}/${filename}"
940         fi
941       done
942     done
943   done
944
945   exit 0
946 }
947
948 # Usage: --help (-h)
949 # Description: Show help text
950 command_help() {
951   printf "Usage: %s [-h] [command [argument]] [parameter [argument]] [parameter [argument]] ...\n\n" "${0}"
952   printf "Default command: help\n\n"
953   echo "Commands:"
954   grep -e '^[[:space:]]*# Usage:' -e '^[[:space:]]*# Description:' -e '^command_.*()[[:space:]]*{' "${0}" | while read -r usage; read -r description; read -r command; do
955     if [[ ! "${usage}" =~ Usage ]] || [[ ! "${description}" =~ Description ]] || [[ ! "${command}" =~ ^command_ ]]; then
956       _exiterr "Error generating help text."
957     fi
958     printf " %-32s %s\n" "${usage##"# Usage: "}" "${description##"# Description: "}"
959   done
960   printf -- "\nParameters:\n"
961   grep -E -e '^[[:space:]]*# PARAM_Usage:' -e '^[[:space:]]*# PARAM_Description:' "${0}" | while read -r usage; read -r description; do
962     if [[ ! "${usage}" =~ Usage ]] || [[ ! "${description}" =~ Description ]]; then
963       _exiterr "Error generating help text."
964     fi
965     printf " %-32s %s\n" "${usage##"# PARAM_Usage: "}" "${description##"# PARAM_Description: "}"
966   done
967 }
968
969 # Usage: --env (-e)
970 # Description: Output configuration variables for use in other scripts
971 command_env() {
972   echo "# dehydrated configuration"
973   load_config
974   typeset -p CA LICENSE CERTDIR CHALLENGETYPE DOMAINS_D DOMAINS_TXT HOOK HOOK_CHAIN RENEW_DAYS ACCOUNT_KEY ACCOUNT_KEY_JSON KEYSIZE WELLKNOWN PRIVATE_KEY_RENEW OPENSSL_CNF CONTACT_EMAIL LOCKFILE
975 }
976
977 # Main method (parses script arguments and calls command_* methods)
978 main() {
979   COMMAND=""
980   set_command() {
981     [[ -z "${COMMAND}" ]] || _exiterr "Only one command can be executed at a time. See help (-h) for more information."
982     COMMAND="${1}"
983   }
984
985   check_parameters() {
986     if [[ -z "${1:-}" ]]; then
987       echo "The specified command requires additional parameters. See help:" >&2
988       echo >&2
989       command_help >&2
990       exit 1
991     elif [[ "${1:0:1}" = "-" ]]; then
992       _exiterr "Invalid argument: ${1}"
993     fi
994   }
995
996   [[ -z "${@}" ]] && eval set -- "--help"
997
998   while (( ${#} )); do
999     case "${1}" in
1000       --help|-h)
1001         command_help
1002         exit 0
1003         ;;
1004
1005       --env|-e)
1006         set_command env
1007         ;;
1008
1009       --cron|-c)
1010         set_command sign_domains
1011         ;;
1012
1013       --signcsr|-s)
1014         shift 1
1015         set_command sign_csr
1016         check_parameters "${1:-}"
1017         PARAM_CSR="${1}"
1018         ;;
1019
1020       --revoke|-r)
1021         shift 1
1022         set_command revoke
1023         check_parameters "${1:-}"
1024         PARAM_REVOKECERT="${1}"
1025         ;;
1026
1027       --cleanup|-gc)
1028         set_command cleanup
1029         ;;
1030
1031       # PARAM_Usage: --full-chain (-fc)
1032       # PARAM_Description: Print full chain when using --signcsr
1033       --full-chain|-fc)
1034         PARAM_FULL_CHAIN="1"
1035         ;;
1036
1037       # PARAM_Usage: --ipv4 (-4)
1038       # PARAM_Description: Resolve names to IPv4 addresses only
1039       --ipv4|-4)
1040         PARAM_IP_VERSION="4"
1041         ;;
1042
1043       # PARAM_Usage: --ipv6 (-6)
1044       # PARAM_Description: Resolve names to IPv6 addresses only
1045       --ipv6|-6)
1046         PARAM_IP_VERSION="6"
1047         ;;
1048
1049       # PARAM_Usage: --domain (-d) domain.tld
1050       # PARAM_Description: Use specified domain name(s) instead of domains.txt entry (one certificate!)
1051       --domain|-d)
1052         shift 1
1053         check_parameters "${1:-}"
1054         if [[ -z "${PARAM_DOMAIN:-}" ]]; then
1055           PARAM_DOMAIN="${1}"
1056         else
1057           PARAM_DOMAIN="${PARAM_DOMAIN} ${1}"
1058          fi
1059         ;;
1060
1061       # PARAM_Usage: --keep-going (-g)
1062       # PARAM_Description: Keep going after encountering an error while creating/renewing multiple certificates in cron mode
1063       --keep-going|-g)
1064         PARAM_KEEP_GOING="yes"
1065         ;;
1066
1067       # PARAM_Usage: --force (-x)
1068       # PARAM_Description: Force renew of certificate even if it is longer valid than value in RENEW_DAYS
1069       --force|-x)
1070         PARAM_FORCE="yes"
1071         ;;
1072
1073       # PARAM_Usage: --no-lock (-n)
1074       # PARAM_Description: Don't use lockfile (potentially dangerous!)
1075       --no-lock|-n)
1076         PARAM_NO_LOCK="yes"
1077         ;;
1078
1079       # PARAM_Usage: --ocsp
1080       # PARAM_Description: Sets option in CSR indicating OCSP stapling to be mandatory
1081       --ocsp)
1082         PARAM_OCSP_MUST_STAPLE="yes"
1083         ;;
1084
1085       # PARAM_Usage: --privkey (-p) path/to/key.pem
1086       # PARAM_Description: Use specified private key instead of account key (useful for revocation)
1087       --privkey|-p)
1088         shift 1
1089         check_parameters "${1:-}"
1090         PARAM_ACCOUNT_KEY="${1}"
1091         ;;
1092
1093       # PARAM_Usage: --config (-f) path/to/config
1094       # PARAM_Description: Use specified config file
1095       --config|-f)
1096         shift 1
1097         check_parameters "${1:-}"
1098         CONFIG="${1}"
1099         ;;
1100
1101       # PARAM_Usage: --hook (-k) path/to/hook.sh
1102       # PARAM_Description: Use specified script for hooks
1103       --hook|-k)
1104         shift 1
1105         check_parameters "${1:-}"
1106         PARAM_HOOK="${1}"
1107         ;;
1108
1109       # PARAM_Usage: --out (-o) certs/directory
1110       # PARAM_Description: Output certificates into the specified directory
1111       --out|-o)
1112         shift 1
1113         check_parameters "${1:-}"
1114         PARAM_CERTDIR="${1}"
1115         ;;
1116
1117       # PARAM_Usage: --challenge (-t) http-01|dns-01
1118       # PARAM_Description: Which challenge should be used? Currently http-01 and dns-01 are supported
1119       --challenge|-t)
1120         shift 1
1121         check_parameters "${1:-}"
1122         PARAM_CHALLENGETYPE="${1}"
1123         ;;
1124
1125       # PARAM_Usage: --algo (-a) rsa|prime256v1|secp384r1
1126       # PARAM_Description: Which public key algorithm should be used? Supported: rsa, prime256v1 and secp384r1
1127       --algo|-a)
1128         shift 1
1129         check_parameters "${1:-}"
1130         PARAM_KEY_ALGO="${1}"
1131         ;;
1132
1133       *)
1134         echo "Unknown parameter detected: ${1}" >&2
1135         echo >&2
1136         command_help >&2
1137         exit 1
1138         ;;
1139     esac
1140
1141     shift 1
1142   done
1143
1144   case "${COMMAND}" in
1145     env) command_env;;
1146     sign_domains) command_sign_domains;;
1147     sign_csr) command_sign_csr "${PARAM_CSR}";;
1148     revoke) command_revoke "${PARAM_REVOKECERT}";;
1149     cleanup) command_cleanup;;
1150     *) command_help; exit 1;;
1151   esac
1152 }
1153
1154 # Determine OS type
1155 OSTYPE="$(uname)"
1156
1157 # Check for missing dependencies
1158 check_dependencies
1159
1160 # Run script
1161 main "${@:-}"